package xyz.danielcortes.controllers.categoria;

import java.util.List;
import javax.swing.JComboBox;
import javax.swing.JOptionPane;
import xyz.danielcortes.models.Categoria;
import xyz.danielcortes.repository.CategoriaRepository;
import xyz.danielcortes.views.categoria.CategoriaUpdatePanel;

public class CategoriaUpdateController {

  private CategoriaUpdatePanel view;
  private CategoriaRepository categoriaRepository;

  public CategoriaUpdateController(CategoriaUpdatePanel view) {
    this.view = view;
    this.categoriaRepository = new CategoriaRepository();

    this.setupListeners();
  }

  private void setupListeners() {
    this.view.getCategoriaCombo().addActionListener(e -> {
      Categoria selected = (Categoria) view.getCategoriaCombo().getSelectedItem();
      if(selected != null)
        this.view.getNombreField().setText(selected.getNombre());
    });
    this.view.getNombreField().addActionListener(e -> this.update());
    this.view.getUpdateButton().addActionListener(e -> this.update());
  }

  private void update() {
    Categoria original = (Categoria) this.view.getCategoriaCombo().getSelectedItem();
    if (!validateOriginal(original)) return;

    String nombre = this.view.getNombreField().getText();
    if (!validateNombre(nombre)) return;

    assert original != null;
    original.setNombre(nombre);
    categoriaRepository.update(original);

    this.loadCategoriaCombo();
    this.view.getNombreField().requestFocus();
  }

  private boolean validateOriginal(Categoria original) {
    if (original == null) {
      JOptionPane.showMessageDialog(
          null,
          "No hay categoria seleccionada",
          "Error",
          JOptionPane.ERROR_MESSAGE
      );
      return false;
    }
    return true;
  }

  private boolean validateNombre(String nombre) {
    if (nombre == null) {
      JOptionPane.showMessageDialog(
          this.view.getContentPane(),
          "El nombre es nulo",
          "Error",
          JOptionPane.ERROR_MESSAGE);
      return false;
    } else if (nombre.isEmpty()) {
      JOptionPane.showMessageDialog(this.view.getContentPane(),
          "El nombre esta vacío",
          "Error",
          JOptionPane.ERROR_MESSAGE);
      return false;
    }
    return true;
  }

  public void reload() {
    this.loadCategoriaCombo();
  }

  private void loadCategoriaCombo() {
    List<Categoria> categorias = this.categoriaRepository.getAll();
    JComboBox<Categoria> combobox = this.view.getCategoriaCombo();
    combobox.removeAllItems();
    for (Categoria categoria : categorias) {
      combobox.addItem(categoria);
    }
  }

  public CategoriaUpdatePanel getView() {
    return view;
  }
}
